-- KikiRools Panel


WinItem = class(Turbine.UI.Lotro.Window);

function WinItem:Constructor(profile)
	Turbine.UI.Lotro.Window.Constructor(self)
	self:SetText(gLang.WINTITLE);
	self:SetMouseVisible(false);
	self:SetSize(320,100);
	self:SetVisible(false);

	-- constantes diverses
	self.font = Turbine.UI.Lotro.Font.Verdana12;
	self.fontColor = Turbine.UI.Color(1,1,1)
	
	-- Recupere les donnes associes
	self.settingsName = profile;
	self.settings = Kiki.Commons.Settings(profile, { top=0; left=0; } );

	-- tracking de la position
	self.PositionChanged = function (sender,args)
		self.settings.top = self:GetTop();
		self.settings.left = self:GetLeft();
	end
	
	-- Positionne sur l'ecran
	self:SetPosition(self.settings.left,self.settings.top);

	-- Force le positionne sur l'ecran
	Kiki.Commons.Onscreen(self);

	local top = 50;
	local left = 15;
	local c;
	
	-- Zone de saisie de l'identifiant d'objet
	c = Turbine.UI.Lotro.TextBox();
	c:SetParent(self);
	c:SetSize(100,20);
	c:SetPosition(left,top);
	c:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	c:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	c:SetMultiline(false);
	self.input = c;
	self.lastText="";
	-- Lorsque le contenu change, on tente la mise en place du quickslot et de l'info
	self.input.TextChanged = function()
		local text = self.input:GetText() ;
		if text ~= self.lastText then
			-- nouveau texte, on le mmorise...
			self.lastText = text;
			-- On tente le tip !
			self:Show(text);
		end
	end
		
	left=left+c:GetWidth()+10;

	-- Positionne le texte d'ID (le bouton)
	c = Turbine.UI.Lotro.GoldButton();
	c:SetSize(130,20);
	c:SetVisible(true);	        
	c:SetParent(self);
	c:SetPosition(left, top);
	c:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	c:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	c:SetText("...");
	self.id=c;
	self.id.Click=function()
		self.input:SetText("");
		self.input:Focus();
	end	
	
	left=left+c:GetWidth()+10;

	-- Positionne le quickslot
	c = Turbine.UI.Lotro.Quickslot();
	c:SetSize(35,35);
	c:SetVisible(true);	        
    c:SetAllowDrop(false); 
    c:SetEnabled(false);	
	c:SetParent(self);
	c:SetPosition(left, top-7);
	self.qs=c;
	
	left=left+c:GetWidth()+10;
	
	
end

-- Construction d'un shortcut
makesc = function(hex, quickslot) 
	local shortcut = Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Item , string.format('0x0000000000000000,0x%s', hex ))
	quickslot:SetShortcut( shortcut );
	return shortcut;
end

function WinItem:Show(id)
    local rc, sc = pcall(makesc, id, self.qs);
    if rc==true then
		self.qs.MouseDown=function(s,a)
			-- hack to prevent real item from being consumed by a click
			self.qs:SetShortcut(nil);
			self.qs:SetShortcut(sc);
		end	
		self.qs.DragDrop=function()
		end
		-- Positionne le texte du bouton, et active le bouton
	    self.id:SetText(string.format("<Examine:IIDDID:0x0000000000000000:0x%s>ID: %s<\Examine>",id,id));
		self.id:SetEnabled(true);
	else
		-- Passe le bouton en disable
		self.id:SetText("Id invalide");
		self.id:SetEnabled(false);
		-- Annulation du shortcut
		self.qs:SetShortcut(Turbine.UI.Lotro.Shortcut());
	end
end


function WinItem:Unload()
	self.settings:Save(self.settingsName);
end

wItem = WinItem(gPluginName.."_panel"); 


